typedef unsigned short u16;

//macro to change the video mode
#define SetMode(mode) REG_DISPCNT = (mode)

//define some video addresses
#define REG_DISPCNT *(volatile unsigned short*)0x4000000

#define BGPaletteMem ((unsigned short*)0x5000000)

#define REG_VCOUNT *(volatile unsigned short*)0x4000006

#define REG_DISPSTAT *(volatile unsigned short *)0x4000004

//define object attribute memory state address
#define SpriteMem ((unsigned short*)0x7000000)

//define object attribute memory image address
#define SpriteData ((unsigned short*)0x6010000)

//define object attribute memory palette address
#define SpritePal ((unsigned short*)0x5000200)

//misc sprite constants
#define OBJ_MAP_2D 0x0
#define OBJ_MAP_1D 0x40
#define OBJ_ENABLE 0x1000

//attribute0 stuff
#define ROTATION_FLAG 0x100
#define SIZE_DOUBLE 0x200
#define MODE_NORMAL 0x0
#define MODE_TRANSPARENT 0x400
#define MODE_WINDOWED 0x800
#define MOSAIC 0x1000
#define COLOR_16 0x0000
#define COLOR_256 0x2000
#define SQUARE 0x0
#define TALL 0x4000
#define WIDE 0x8000

//attribute1 stuff
#define HORIZONTAL_FLIP 0x1000
#define VERTICAL_FLIP 0x2000
#define SIZE_8 0x0
#define SIZE_16 0x4000
#define SIZE_32 0x8000
#define SIZE_64 0xC000

//attribute2 stuff
#define PRIORITY(n) ((n) << 10)
#define PALETTE(n) ((n) << 12)

#define TIMER_OVERFLOW 0x4
#define TIMER_IRQ_ENABLE 0x40
#define TIMER_ENABLE 0x80

#define TIMER_FREQUENCY_SYSTEM	0x0
#define TIMER_FREQUENCY_64	0x1
#define TIMER_FREQUENCY_256	0x2
#define TIMER_FREQUENCY_1024	0x3

#define REG_TM0CNT *(volatile u16*)0x4000102
#define REG_TM1CNT *(volatile u16*)0x4000106
#define REG_TM2CNT *(volatile u16*)0x400010A
#define REG_TM3CNT *(volatile u16*)0x400010E

#define REG_TM0D *(volatile u16*)0x4000100
#define REG_TM1D *(volatile u16*)0x4000104
#define REG_TM2D *(volatile u16*)0x4000108
#define REG_TM3D *(volatile u16*)0x400010C

#define REG_INTERRUPT	*(u32*)0x3007FFC

#define INT_TIMER1 	0x0010
#define INT_TIMER0 	0x0008
