//DEFINITION TYPES
typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned long u32;

//DEFINITION ADDRESSES
#define ButtonMem	((u16*)0x4000130)
#define SpritePal	((u16*)0x5000200)
#define SpriteData	((u16*)0x6010000)
#define SpriteMem	((u16*)0x7000000)
#define BGPaletteMem	((u16*)0x5000000)

//DEFINITION REGISTRES
//#define REG_KEYCNT 	*(volatile u16*)0x04000132
//#define REG_DMA3SAD 	*(volatile u16*)0x40000D4
//#define REG_DMA3DAD	*(volatile u16*)0x40000D8
//#define REG_DMA3CNT	*(volatile u16*)0x40000DC
//#define REG_IME		*(volatile u16*)0x4000208
//#define REG_IF		*(volatile u16*)0x4000202
//#define REG_IE		*(volatile u16*)0x4000200
//#define REG_DISPCNT	*(volatile u16*)0x4000000

//DEFINITION MACROS

#define SetMode(mode) 	REG_DISPCNT = (mode)

//DEFINITION ELEMENTS GRAPHIQUES
#define SIZE_8		0x0
#define SIZE_16 	0x4000
#define SIZE_32 	0x8000
#define SIZE_64 	0xC000
#define SIZE_32x64 	0xE000
#define OBJ_ENABLE 	0x1000
#define OBJ_MAP_1D 	0x40
//DEFINITION TIMERS
#define INT_TIMER0	0x0008
#define INT_TIMER1	0x0010
#define INT_TIMER2	0x0020
#define INT_TIMER3	0x0040
#define TIMER_ENABLE	0x80
#define TIMER_FREQUENCY_SYSTEM	0x0
#define TIMER_FREQUENCY_64	0x1
#define TIMER_FREQUENCY_256	0x2
#define TIMER_FREQUENCY_1024	0x3

//DEFINITION BACKGROUND
#define COLOR_256 	0x2000
#define BG0_ENABLE 	0x100
#define BG1_ENABLE	0x200
#define BG2_ENABLE	0x400
#define BG3_ENABLE	0x800
#define WRAPAROUND	0x1

//DEFINITION DMA
//#define DMA_ENABLE	0x80000000
#define DMA_TIMING_IMMEDIATE	0x00000000
#define DMA_16		0x00000000
#define DMA_32		0x04000000
#define DMA16NOW	(DMA_ENABLE | DMA_TIMING_IMMEDIATE | DMA_16)
#define DMA32NOW	(DMA_ENABLE | DMA_TIMING_IMMEDIATE | DMA_32)

//DEFINITION BOUTONS GBA
#define KEY_A 		1
#define KEY_B 		2
#define KEY_SELECT 	4
#define KEY_START 	8
#define KEY_RIGHT 	16
#define KEY_UP 	64
#define KEY_DOWN 	128
#define KEY_R 		256
#define KEY_L 		512
#define INT_BUTTON	0x1000

// ajout personnel
#define REG_INTERRUPT *(u32 *)0x3007FFC
//#define REG_TM0CNT *(u16 *)0x4000102
#define REG_TM0D *(u16*) 0x4000100
#define TIMER_IRQ_ENABLE 0x40
