#include <gba.h>
#include "def.h"
#include "sprite.h"

Sprite sprites[2];

void WaitForVsync(void);
void UpdateSpriteMemory(void);

int val=0;
void MyHandler()
{
    REG_IME = 0x00;
    if ((REG_IF & INT_TIMER0) == INT_TIMER0)
    {
 		val++;
		if(val==100)val=0;

		//Set two sprites visible with appropriate memory (attribute 2)
		sprites[0].attribute2 = (val/10)*2;
		sprites[1].attribute2 = (val%10)*2;
    }
    
    REG_IF = INT_TIMER0;
    REG_IME = 1;
}

int main(void) {
	
	signed short x = 50, y = 50;
	int n;

	//set the video mode--mode 2 with sprites
	SetMode(2 | OBJ_ENABLE | OBJ_MAP_1D);

	//move all sprites offscreen to hide them
	for(n = 0; n < 2; n++)
	{
		sprites[n].attribute0 = COLOR_256 | y;;
		sprites[n].attribute1 = SIZE_8 | (x+(n*10));
	}

	for(n = 0; n < 128; n++){
		SpritePal[n] = RGB8(255,255,255);
	}

	//copy the sprite image into memory
	for(n = 0; n < 640; n++) {
		 SpriteData[n] =  ((short*)digits)[n];
	}


	REG_TM0CNT = (TIMER_FREQUENCY_64 | TIMER_ENABLE | TIMER_IRQ_ENABLE);
	REG_IME = 0x00; 
    REG_INTERRUPT = (u32)MyHandler;
    REG_IE  |= INT_TIMER0 ;
    REG_IME = 1;

	while(1)
	{
		UpdateSpriteMemory();
	}
}


void WaitForVsync(void)
{
	while((REG_DISPSTAT & 1));
}

void UpdateSpriteMemory(void)
{
	int n;
	unsigned short* temp;
	temp = (unsigned short*)sprites;
	for(n = 0; n < 2*4; n++)
	{
		SpriteMem[n] = temp[n];
	}
}
